/*
 *   Copyright (C) 1997, 1998, 1999 Loic Dachary
 *
 *   This program is free software; you can redistribute it and/or modify it
 *   under the terms of the GNU General Public License as published by the
 *   Free Software Foundation; either version 2, or (at your option) any
 *   later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#include <memory.h>

unsigned char iso2letter_unaccent[256];
unsigned char iso2letter_transparent[256];
static int iso_done = 0;

unsigned char* unaccent(unsigned char* string, int string_length)
{
  if(!iso_done) {
    char* tmp = "AAAAAAACEEEEIIIIDNOOOOOxOUUUUYdBaaaaaaaceeeeiiiionooooo/ouuuuydy";
    int i;
    for(i = 0; i < 255; i++) {
      iso2letter_unaccent[i] = i;
      iso2letter_transparent[i] = i;
    }
    memcpy(iso2letter_unaccent + 0xc0, tmp, strlen(tmp));

    iso_done = 1;
  }

  {
    unsigned char* tmp = string;
    int i;
    for(i = 0; i < string_length; i++)
      tmp[i] = iso2letter_unaccent[(unsigned char)tmp[i]];
  }
  return string;
}
